BOOT_SIZE	EQU	512

BOOTSEC	STRUC
bsJump	DB	3 DUP (?)
bsOemName	DB	8 DUP (?)
bsBPB	DB	SIZE BPB DUP (?)
bsDriveNumber	DB	?
bsReserved1	DB	?
bsBootSignature	DB	?
bsVolumeID	DD	?
bsVolumeLabel	DB	11 DUP (?)
bsFileSysType	DB	8 DUP (?)
BOOTSEC	ENDS

BIGFATBOOTSEC	STRUC
bgbsJump	DB	3 DUP (?)
bgbsOemName	DB	8 DUP (?)
bgbsBPB	DB	SIZE BIGFATBPB DUP (?)
bgbsDriveNumber	DB	?
bgbsReserved1	DB	?
bgbsBootSignature	DB	?
bgbsVolumeID	DD	?
bgbsVolumeLabel	DB	11 DUP (?)
bgbsFileSysType	DB	8 DUP (?)
BIGFATBOOTSEC	ENDS
BOOTSECTRAILSIGL	EQU	0000H
BOOTSECTRAILSIGH	EQU	0AA55H
BOOTSECTRAILSIG	EQU	0AA550000H
OFFSETTRLSIG	EQU	<(BOOT_SIZE-4)>
BOOT_SIGNATURE	EQU	<(BOOT_SIZE-2)>
BOOT_TRAILSIG	EQU	BOOTSECTRAILSIGH
DOREAD_OFFSET	EQU	014BH
DOREAD_MOVDL_OFFSET	EQU	0016H
DOREAD_LENGTH	EQU	0035H
MBR_BOOTFAILBACKUP	EQU	6
MBR_BOOTFLBCKUP	EQU	MBR_BOOTFAILBACKUP
SECONDBOOTSECSIG	EQU	41615252H
SECONDBOOTSECSIGL	EQU	5252H
SECONDBOOTSECSIGH	EQU	4161H

BIGFATBOOTFSINFO	STRUC
bfFSInf_Sig	DD	?
bfFSInf_free_clus_cnt	DD	?
bfFSInf_next_free_clus	DD	?
bfFSInf_resvd	DD	3 DUP (?)
BIGFATBOOTFSINFO	ENDS
EXT_BIGIBMBOOT_FSINFO	EQU	<BIGFATBOOTFSINFO>
EXT_BGFSInf_Sig	EQU	<bfFSInf_Sig>
EXT_BGFSInf_free_clus_cnt	EQU	<bfFSInf_free_clus_cnt>
EXT_BGFSInf_resvd	EQU	<bfFSInf_next_free_clus>
FSINFOSIG	EQU	61417272H
FSINFOSIGL	EQU	7272H
FSINFOSIGH	EQU	6141H
OFFSETFSINFOFRMSECSTRT	EQU	<(OFFSETTRLSIG-SIZE BIGFATBOOTFSINFO)>
OFFSETEXTFSINFOFRMSECSTRT	EQU	<OFFSETFSINFOFRMSECSTRT>
BS2BYTJMP	EQU	0EBH
BS3BYTJMP	EQU	0E9H
BOOT_2BYTJMP	EQU	BS2BYTJMP
BOOT_3BYTJMP	EQU	BS3BYTJMP
BSEXTSIG	EQU	29H
EXT_BOOT_SIGNATURE	EQU	BSEXTSIG
BSFSTYPFAT12	EQU	<"FAT12   ">
BSFSTYPFAT16	EQU	<"FAT16   ">
BSFSTYPFAT32	EQU	<"FAT32   ">
ifdef NOTFAT32
IBMLOADSIZE	EQU	3
else
IBMLOADSIZE	EQU	4
endif
